/*****************************************************************************
 *
 * ProxFunctions.js for sidki's Proxomitron config
 * Last edited: 2005-05-19
 *
 *****************************************************************************/

// Parse the whole shebang only if not already done so.
var prxDone;
prxDone = (typeof prxDone == "undefined") ? 0 : prxDone + 1;
if (!prxDone) {

  /******************************* PAGE START ********************************/

  /* ====================================
     Page Load Timer Part I. - hpguru
     ==================================== */

  var prxTimer;
  if (prxTimer) {
    var prxST = new Date();
  }

  /* ====================================
     Set some flags.
     ==================================== */

  // Debug?
  var prxDebug;
  //prxDebug = 1;

  // Set this flag until the very last line of this script. - Paul Rupe
  var prxLoading = 1;

  // Declare the flag that counts replacements of ad scripts with dummy.js.
  var prxDummy = 0;

  // Set the main target element - verified when the page has been loaded.
  var prxElement = document.documentElement;

  // Test for "document.all" support.
  var prxDAll = (document.all) ? 1 : 0;

  // Force offscreen buffering to speed up rendering, default is auto. - hpguru
  window.offscreenBuffering = true;

  // Detect IE, Mozilla, Opera, and Netscape. - hpguru
  var prxIsIE =
    (prxDAll && document.getElementById && !window.opera) ? 1 : 0;
  var prxIsMoz =
   (!prxDAll && document.getElementById && !window.opera) ? 1 : 0;
  var prxIsOp = (window.opera) ? 1 : 0;
  var prxIsNN = (document.layers) ? 1 : 0;

  /* ====================================
     Returns 1 if the given target refers to an existing frame or window, 0
     otherwise. - Paul Rupe, sidki
     ==================================== */

  function PrxCheckLinkTarget(tg) {
    var i, f, t = tg.toString();

    // Those are ok.
    if (t == "_top" ||
      t == "_parent" ||
      t == "_self" ||
      t == "_main" ||
      t == "_content" || (prxIsIE && t == "_search")) {
      return 1;
    }

    // Always reject _blank, etc (added for speed reasons).
    if (t.match(/^(_|)(blank|new)$/i)) {
      return 0;
    }

    // Names starting with prx_ are ok
    // (e.g. bookmarklets opening in a new window).
    if (t.indexOf("prx_") == 0) {
      return 1;
    }

    // If the target matches an existing frame, ok (except for NN4).
    if (!prxIsNN) {
      for (i = 0, f = window.parent.frames; i < f.length; i++) {
        eval("try {var v = f[i].name} catch(er) {var v = 0}");
        if (v == t) {
          return 1;
        }
      }
    }

    // Otherwise, no soup for you.
    return 0;
  }

  /* ====================================
     Returns the domain portion of the given URL.  Probably not exactly right,
     but close enough. - Paul Rupe
     ==================================== */

  function PrxGetDomain(url) {
    var a = url.indexOf("://"), b, c;
    if (a == -1) {
      return null;
    }
    url = url.substr(a + 3);
    b = url.indexOf("/");
    if (b != -1) {
      url = url.substr(0, b);
    }
    b = url.indexOf("@");
    if (b != -1) {
      url = url.substr(b + 1);
    }
    b = url.indexOf(":");
    if (b != -1) {
      url = url.substr(0, b);
    }
    for (a = 0, b = -1;;) {
      a = url.indexOf(".", a + 1);
      if (a == -1) {
        break;
      }
      c = url.indexOf(".", a + 1);
      if (c == -1) {
        break;
      }
      b = a;
    }
    url = url.substr(b + 1);
    return url;
  }

  /* ====================================
     Loops until the bottom of the page is accessible via DOM, called by other
     functions. - JD, sidki
     ==================================== */

  function PrxLoop(func) {
    var countX = 0;

    function LoopMe() {
      if (countX < 200) {
        if (document.getElementById("proxDOM")) {
          func();
        } else {
          countX++;
          PrxOldSetTimeout(LoopMe, 300);
        }
      }
    }

    LoopMe();
  }

  /* ====================================
     Create Popup Blocked Notification. - Michael Brschgens, JD
     ==================================== */

  var prxPopupN, prxCfgDir;
  if (prxPopupN) {

    // The main notification function, called by the Anti-Popup Code.
    function PrxPopupURL(address) {

      // Declare the code that is appended on request.
      function PrxPopupAppend() {
        var s, f = "http:/" + prxCfgDir + "PopUp.wav";

        // Declare different sound code, depending on the browser.
        if (prxIsIE) {
          s = document.createElement("bgsound");
          s.setAttribute("src", f);
        } else {
          if (prxIsMoz) {
            s = document.createElement("embed");
            s.setAttribute("src", f);
            s.setAttribute("hidden", "true");
          } else {
            if (prxIsOp) {
              s = document.createElement("iframe");
              s.setAttribute("src", "http:/" + prxCfgDir + "OperaSound.html?" + f);
              s.setAttribute("width", "0");
              s.setAttribute("height", "0");
              s.setAttribute("style", "border:none");
            }
          }
        }

        // Define the image links.
        var p = document.createElement("img");
        p.setAttribute("src", "http:/" + prxCfgDir + "info.gif");
        p.setAttribute("width", "17");
        p.setAttribute("height", "17");
        p.setAttribute("border", "0");
        p.setAttribute("title", "PopUp blocked: " + address);

        var l = document.createElement("a");
        l.setAttribute("href", address);
        l.setAttribute("target", "_top");
        l.appendChild(p);

        // Append the links to the page.
        document.getElementById("proxDOM").appendChild(l);
        document.getElementById("proxDOM").appendChild(s);
      }

      // Loop until the page is ready for appending.
      PrxLoop(PrxPopupAppend);
    }

  }

  /* ====================================
     Anti-Popup Code Part I. - Scott R. Lemmon
     ==================================== */

  var prxPopup, prxFrameset;
  if (prxPopup) {
    var prxLC = new Date(0), PrxRealOpen = window.open;

    function PrxOMUp(e) {
      if (document.PrxOnmouseup) {
        if (!e) {
          e = event;
        }
        document.PrxOnmouseup(e);
      }
      prxLC = new Date();
    }

    // To reroute showModalDialog/showModelessDialog, the second parameter MUST
    // be tested/converted to string if need be since dialogs can also accept
    // objects, whereas "open" only accepts strings as second parameter.
    // A further problem can arise in the third parameter.  The dialog calls
    // have a slightly different format.  Size for instance is passed
    // differently and uses a semicolon instead of an equal sign. - TEggHead
    function PrxOpen(url, enam, atr) {

      // Add this line to make sure the second param is a string. - TEggHead
      var nam = (typeof enam == "object") ? "Dialog" :
        (enam == null) ? "Blank" : enam;

      // Allow windows referring to trusted target names - Paul Rupe
      if (nam && PrxCheckLinkTarget(nam)) {
        return (PrxRealOpen(url, nam, atr));
      }

      // If the page has already loaded and the mouse was clicked within 2
      // seconds or we are inside a frameset, then allow the window.
      var cdt = new Date();
      cdt.setTime(cdt.getTime() - prxLC.getTime());
      if (!prxLoading && (cdt.getSeconds() < 2 && !window.onclick || prxFrameset)) {
        if (atr) {
          return (PrxRealOpen(url, nam, PrxWOA(atr)));
        } else {
          return (PrxRealOpen(url, nam));
        }
      }

      // Grab the PopUp URL for notification function.
      if (prxPopupN) {
        PrxPopupURL(url);
      }
      return true;
    }

    var prxModAtr;

    function PrxWOA(atr) {
      if (!prxModAtr) {
        return (atr);
      }
      var yatr = (prxModAtr == 2) ? 1 : 0;
      var xatr = "location=1,status=1,scrollbars=1,resizable=1,left=0,top=50";
      xatr += "toolbar=" + yatr + ",menubar=" + yatr;
      if (atr) {
        var hm;
        hm = atr.match(/height(=|:)([0-9]+)/i);
        if (hm) {
          xatr += ",height=" + hm[2];
        } else {
          xatr += ",height=480";
        }
        hm = atr.match(/width(=|:)([0-9]+)/i);
        if (hm) {
          xatr += ",width=" + hm[2];
        } else {
          xatr += ",width=640";
        }
      } else {
        xatr += ",height=480,width=640";
      }
      return (xatr);
    }

    window.open = PrxOpen;

    // IE Specific Methods. - Homeric
    window.showModalDialog = PrxOpen;
    window.showModelessDialog = PrxOpen;
  }

  /* ====================================
     Intercept "window.resizeTo" and "window.moveTo".  Block fullscreen
     resizing, but allow the rest.  Note that Mozilla/Nescape windows can also
     be resized with "outerWidth=this; outerHeight=that".  This gets blocked
     the hard way in the "JSProperties" list. - sidki
     ==================================== */

  var prxResize;
  if (prxResize) {
    var PrxOldResizeTo = window.resizeTo, PrxOldMoveTo = window.moveTo;

    function PrxResizeTo(wide, high) {
      if (wide >= screen.availWidth || high >= screen.availHeight) {
        PrxFooter("resizeTo blocked", wide + "x" + high);
        return true;
      } else {
        PrxFooter("resizeTo allowed", wide + "x" + high);
        return (PrxOldResizeTo(wide, high));
      }
    }
    function PrxMoveTo(x, y) {
      if (x <= 1 || y <= 1) {
        PrxFooter("moveTo blocked", x + "x" + y);
        return true;
      } else {
        PrxFooter("moveTo allowed", x + "x" + y);
        return (PrxOldMoveTo(x, y));
      }
    }

    window.resizeTo = PrxResizeTo;
    window.moveTo = PrxMoveTo;
  }

  /* ====================================
     Define the properties as renamed by the "Block: Sel. JS Properties"
     filters. - sidki
     ==================================== */

  var prxNav;
  if (prxNav) {
    if (navigator.PRXuserAgent) {
      navigator.PRXappVersion = navigator.PRXuserAgent.match(/\d[^)]+\)/).toString();
      navigator.PRXappMinorVersion = navigator.PRXappVersion;
      if (navigator.PRXuserAgent.indexOf("Mozilla/4.0") == 0) {
        navigator.PRXappName = "Microsoft Internet Explorer";
      } else {
        if (navigator.PRXuserAgent.indexOf("Mozilla/") == 0) {
          navigator.PRXappName = "Netscape";
        } else {
          if (navigator.PRXuserAgent.indexOf("Opera/") == 0) {
            navigator.PRXappName = "Opera";
          } else {
            navigator.PRXappName = "";
          }
        }
      }
    }
    navigator.PRXcpuClass = "alpha";
    navigator.PRXuserLanguage = "en";
    navigator.PRXbrowserLanguage = "en";
    navigator.PRXsystemLanguage = "en";
    navigator.PRXjavaEnabled = true;
    navigator.PRXcookieEnabled = true;
  }

  /* ====================================
     Disable various Methods. - Paul Rupe, sidki
     ==================================== */

  // Called by Proxomitron instead of the real names.
  var PrxOldSetTimeout = window.setTimeout;
  var PrxOldSetInterval = window.setInterval;

  // Dummy function.
  function PrxDummyZero(string) {
  }

  var prxMeth;
  if (prxMeth) {

    // Override some window manipulation APIs (which never should have existed
    // in first place).
    window.focus = PrxDummyZero;
    window.resizeBy = PrxDummyZero;
    window.moveBy = PrxDummyZero;

    function clipboardData() {
      return true;
    }

    function createPopup() {
      return true;
    }

    // Override these window properties as well.
    status = window.defaultStatus = "";
  }

  /* ====================================
     Provide definitions for properties or common functions that get renamed or
     filtered out and cause subsequent errors. - Paul Rupe
     ==================================== */

  var expires = new Date(0);
  document.PRXcookie = "ProxMessage=GoFigureItOut";

  /* ====================================
     Print messages dynamically to the footer, called by other functions.
     - sidki
     ==================================== */

  function PrxFooter(title, msg) {

    function FWrite() {
      var tag = document.createElement("span");
      tag.setAttribute("class", "Prox");
      tag.style.display = "inline";
      var text = document.createTextNode(" \u2022 " + title + ": " + msg);
      tag.appendChild(text);
      document.getElementById("proxDOM").appendChild(tag);
      return false;
    }

    PrxLoop(FWrite);
  }

  /* ====================================
     Show error messages in the footer.  IE and Mozilla only for now, Opera
     ignores it - sidki
     ==================================== */

  var prxErr;
  if (prxErr) {
    prxErr = 6;

    function PrxError(msg) {
      if (--prxErr >= 0) {
        PrxFooter("JS Error", msg);
      }
      return false;
    }

    if (prxIsMoz) {
      eval("var onerror"); // Avoid strict warning.
    }
    onerror = PrxError;
  }

  /* ====================================
     Alerts to Footer. - sidki
     ==================================== */

  var prxAlertP;
  if (prxAlertP) {
    var PrxOldAlert = window.alert;

    function PrxAlertW(msg) {
      PrxFooter("JS Alert", msg);
    }

    window.alert = PrxAlertW;
  }

  /* ====================================
     Restrict Message Boxes Part I. - Paul Rupe
     ==================================== */

  var prxAlertR;
  if (prxAlertR) {
    if (!prxAlertP) {
      PrxOldAlert = window.alert;
    }
    var PrxOldPrompt = window.prompt;
    var PrxOldConfirm = window.confirm;

    // Set this flag until the very last line of this script.
    var prxAlA = 0;

    var prxAlL = 10;

    // Returns true if alert/confirm/prompt have not been called a bunch of
    // times already, false if they have not.  Used to stop runaway scripts
    // abusing these pop-up functions.
    function PrxCheckAlert() {
      if (!prxAlA) {
        return false;
      }
      if (--prxAlL >= 0) {
        return true;
      }
      if (PrxOldConfirm("*** PROXOMITRON ALERT ***\nThis script is too busy for its own good.  Kill it?")) {
        prxAlA = 0;
        return false;
      } else {
        return true;
      }
    }

    function PrxConfirmR(m) {
      if (!PrxCheckAlert()) {
        return null;
      }
      return PrxOldConfirm(m);
    }

    function PrxPromptR(m, d) {
      if (!PrxCheckAlert()) {
        return null;
      }
      if (!d) {
        d = "";
      }
      return PrxOldPrompt(m, d);
    }

    window.prompt = PrxPromptR;
    window.confirm = PrxConfirmR;
    if (!prxAlertP) {

      function PrxAlertR(m) {
        if (!PrxCheckAlert()) {
          return null;
        }
        return PrxOldAlert(m);
      }

      window.alert = PrxAlertR;
    }
  }

  /* ====================================
     Intercept calls to *.location.replace() Part I. - Paul Rupe, sidki
     ==================================== */

  var prxLoc;
  if (prxLoc) {
    var PrxOldLoc = location.replace;

    function PrxGetLoc(l) {
      if (prxLoading) {
        prxLocURL = l;
      } else {
        PrxOldLoc(l);
      }
      return false;
    }

    window.location.replace = PrxGetLoc;
    window.navigate = PrxGetLoc;
  }

  /* ====================================
     Translate the property into a string for display.  Replace <, >, &, etc.
     with their HTML entities.  Called by other functions - Paul Rupe, sidki
     ==================================== */

  function PrxFuncToString(prop) {
    var c, i, t = "", s = prop.toString();
    if (s.match(/^function /)) {
      s = s.replace(/^function +anonymous *\([^)]*\)\s *\{ */, "");
      s = s.replace(/ *\}$/, "");
    }
    s = s.replace(/^\n/, "");
    for (i = 0; c = s.charAt(i); i++) {
      if (c == "<") {
        t += "&lt;";
      } else {
        if (c == ">") {
          t += "&gt;";
        } else {
          if (c == "&") {
            t += "&amp;";
          } else {
            if (c == "\r") {
              t += "";
            } else {
              if (c == "\n") {
                t += "<br>";
              } else {
                if (c == "'") {
                  t += "\\&#39;";
                } else {
                  if (c == "\"") {
                    t += "&quot;";
                  } else {
                    t += c;
                  }
                }
              }
            }
          }
        }
      }
    }
    return t;
  }

  /* ====================================
     Timers to buttons/links -- Intercept "setInterval" and specified
     "setTimeout" functions.  Write start/stop buttons for them in Opera and
     Gecko browsers, write start/stop links in Internet Explorer. - sidki
     ==================================== */

  var prxITime, prxIInt;
  if (prxITime || prxIInt) {
    var prxTSwitch = 2; // Avoid strict warning.

    // The "onclick" event for the timer buttons.
    function PrxTClick(meth, qfunc, time, id) {
      if (prxTSwitch == 2) {
        prxITime = 0, prxIInt = 0;
      }
      if (prxTSwitch == 1) {
        prxTSwitch = 0;
        if (!prxIsIE) {
          document.getElementById(id).setAttribute("value", meth);
        }
        window.setTimeout = PrxDummyZero;
        window.setInterval = PrxDummyZero;
        if (prxIInt) {
          window.clearInterval(prxIInt);
        }
        if (prxITime) {
          window.clearTimeout(prxITime);
        }
      } else {
        prxTSwitch = 1;
        if (!prxIsIE) {
          document.getElementById(id).setAttribute("value", "      stop      ");
        }
        window.setTimeout = PrxOldSetTimeout;
        window.setInterval = PrxOldSetInterval;
        if (meth == "setTimeout") {
          prxITime = PrxOldSetTimeout(qfunc, time);
        }
        if (meth == "setInterval") {
          prxIInt = PrxOldSetInterval(qfunc, time);
        }
      }
    }

    // The new "setTimeout" and "setInterval" function.
    function PrxSetTimer(meth, func, time) {
      var qfunc = (typeof func == "string") ? "unescape(\"" + escape(func) + "\")" : func;
      if (meth == "setTimeout") {

        // This expression describes the strings that need to be in the
        // setTimeout function in order to get intercepted by Proxomitron.
        // This is *not* Proxomitron language:
        // Prox -> RegExp: "*" -> "." and "+" -> "*".
        var re_i = /((open|slide|scroll|move|_roll)(?![a-z0-9_.]*menu)|.reload|float|rotat|ticker|play|status|marquee|showbanner|loop|tracker|title)[a-z0-9_.]*\(|\.location\s*=|\.getElementBy/i;

        //alert(func.toString());
        if (!func.toString().match(re_i)) {
          window.setTimeout = PrxOldSetTimeout;
          return PrxOldSetTimeout(func, time);
        }
      }
      if (meth == "setInterval") {

        // This expression describes setInterval function strings that *don't*
        // get intercepted by Proxomitron.
        var re_e = /menu[a-z0-9_.]*\(/i;

        //alert(func.toString());
        if (func.toString().match(re_e)) {
          window.setInterval = PrxOldSetInterval;
          return PrxOldSetInterval(func, time);
        }
      }
      var id = "Prox" + Math.random();
      var click = "PrxTClick('" + meth + "'," + qfunc + "," + time + ",'" + id + "');";

      // On right-click run the function once and without delay.
      // Gecko browsers only.
      var rclick = func + ";return false;";
      var overIE = (prxIsIE) ? "\n" : "<br>";
      overIE = time / 1000 + " second(s):" + overIE + PrxFuncToString(func);
      var over = "PrxFlShow('<div class=ProxFlyCont>" + overIE + "</div>',event,0)";

      function PrxSetTimerAppend() {
        var b;
        if (prxIsIE) {
          var t = document.createTextNode(" " + meth + " ");
          b = document.createElement("a");
          b.setAttribute("title", overIE);
          b.setAttribute("href", "javascript:" + click);
          b.appendChild(t);
        } else {
          b = document.createElement("input");
          b.setAttribute("class", "ProxButton");
          b.setAttribute("id", id);
          b.setAttribute("type", "button");
          b.setAttribute("value", meth);
          b.setAttribute("onmouseover", over);
          b.setAttribute("onmouseout", "PrxFlDHide()");
          b.setAttribute("onclick", click);
          b.setAttribute("oncontextmenu", rclick);
        }
        document.getElementById("proxDOM").appendChild(b);
      }

      return PrxLoop(PrxSetTimerAppend);
    }

    // Intercept "setInterval".
    if (prxIInt) {

      function PrxSetInterval(func, time) {
        PrxSetTimer("setInterval", func, time);
      }

      window.setInterval = PrxSetInterval;
    }

    // Intercept "setTimeout".
    if (prxITime) {

      function PrxSetTimeout(func, time) {
        PrxSetTimer("setTimeout", func, time);
      }

      window.setTimeout = PrxSetTimeout;
    }
  }

  /* ====================================
     Toggle (show/hide) span tags with specified classname or ID. - sidki
     ==================================== */

  function PrxToggle(nam, atr, tag, tog) {
    var tags = window.document.getElementsByTagName(tag);
    for (var i = 0; i < tags.length; i++) {
      if ((atr == "cl" && nam == tags[i].className) ||
        (atr == "id" && nam == tags[i].id)) {
        if (tags[i].style.display != "inline") {
          tags[i].style.display = "inline";
        } else {
          if (tog) {
            tags[i].style.display = "none";
          }
        }
        if (tags[i].style.visibility == "hidden") {
          tags[i].style.visibility = "visible";
        } else {
          if (tags[i].style.visibility == "visible") {
            tags[i].style.visibility = "hidden";
          }
        }
      }
    }
  }

  /* ====================================
     Clickable flyover  Part I. - Dynamic Drive, sidki, Martin Konicek
     ==================================== */

  // Pop-it menu - By Dynamic Drive.  For full source code and more DHTML
  // scripts, visit http://www.dynamicdrive.com .  This credit MUST stay intact
  // for use.

  var prxFlObj, prxTidS, prxTidH;

  function PrxFlShow(which, e, movex) {
    if (!prxFrameset && !prxIsNN) {

      // Adjustable variables.
      var offX = 0;
      var offY = 10;
      var tdShow = 800;

      if (!e) {
        e = event;
      }
      prxFlObj = (prxDAll) ?
        document.all.proxFlyover : document.getElementById("proxFlyover");
      if (prxFlObj) {
        prxFlObj.innerHTML = which;

        // Find out the mouse position relative to the viewport. - sidki
        var hereX = e.pageX ? e.pageX : prxElement.scrollLeft + e.clientX;
        var hereY = e.pageY ? e.pageY : prxElement.scrollTop + e.clientY;

        // If the mouse is too close to the viewports right or top edge, move the
        // position of the flyover to the left or bottom.
        var pWidth = prxFlObj.offsetWidth + offX;
        var pHeight = prxFlObj.offsetHeight + offY;
        hereX = (movex && prxElement.clientWidth - e.clientX < pWidth) ?
          hereX - pWidth : hereX + offX;
        hereY = (e.clientY < pHeight) ? hereY + offY : hereY - pHeight;

        // Mozilla's standards-compliant mode needs units, Opera and IE don't
        // care. - sidki
        prxFlObj.style.left = hereX + "px";
        prxFlObj.style.top = hereY + "px";

        PrxFlClearHide();
        PrxFlHide();
        prxTidS = PrxOldSetTimeout("prxFlObj.style.visibility='visible'", tdShow);
      }
    }
  }

  function PrxFlDHide() {
    if (!prxFrameset) {

      // Adjustable variable.
      var tdHide = 800;

      if (window.prxTidS) {
        clearTimeout(prxTidS);
      }
      prxTidH = PrxOldSetTimeout("PrxFlHide()", tdHide);
    }
  }

  function PrxFlHide() {
    if (window.prxFlObj) {
      prxFlObj.style.visibility = "hidden";
    }
  }

  function PrxFlClearHide() {
    if (window.prxTidH) {
      clearTimeout(prxTidH);
    }
  }

  function PrxFlDynHide(e) {
    if (e.toElement && !prxFlObj.contains(e.toElement)) {
      PrxFlHide();
    } else {
      if (!e.toElement) {

        // Determines if one element in contained in another. - Brainjar.com
        var ct = e.currentTarget;
        var rt = e.relatedTarget;
        if (rt && ct != rt) {
          while (rt.parentNode) {
            if ((rt = rt.parentNode) == ct) {
              return true;
            }
          }
          PrxFlHide();
        }

      }
    }
    return false;
  }

  // Make an anchor with the passed information. - Martin Konicek
  function PrxFlLink(dummy, name, url, prefix) {
    var flContent = (prefix) ? prefix : "";
    flContent += "<a href=" + unescape(url) + ">" + name + "</a>";
    return flContent;
  }

  /******************************** PAGE END *********************************/

  /* ====================================
     Creates a button to call a given event handler directly if such a handler
     is defined.  Rather than disable e.g. window.onload completely, this lets
     you call it at will in case some page requires it to function. - Paul Rupe
     ==================================== */

  function PrxEventButton(objn, propn) {
    var fpropn = objn + ".Prx" + propn;
    eval("var prop = " + objn + "." + propn);
    if (prop) {
      eval(fpropn + " = prop");
      document.writeln("<span class=\"Prox\" style=\"display:inline\"><button class=\"ProxButton\" " + "onmouseover=\"PrxFlShow('<div class=ProxFlyCont>" + PrxFuncToString(prop) + "</div>',event,0)\" " + "onMouseout=\"PrxFlDHide()\" " + "onclick=\"" + fpropn + "();\">" + propn + "</button></span>");
    }
  }

  /* ====================================
     Various Events to Button - Paul Rupe
     ==================================== */

  function PrxAllEventButton() {
    PrxEventButton("window", "onunload");
    PrxEventButton("window", "onbeforeunload");
    PrxEventButton("window", "onbeforeprint");
    PrxEventButton("window", "onafterprint");
    PrxEventButton("window", "onblur");
    PrxEventButton("window", "onfocus");
    PrxEventButton("window", "onresize");
    PrxEventButton("window", "onscroll");
  }

  /* ====================================
     "onload" Events to Button - Paul Rupe
     ==================================== */

  function PrxOnloadButton() {
    PrxEventButton("window", "onload");

    function PrxClearOnload(a) {
      if (!a) {
        return;
      }
      a.onload = null;
    }

    PrxClearOnload(document);
    PrxClearOnload(document.body);
    PrxClearOnload(window);
  }

  /* ====================================
     Set the main target element depending on rendering mode and browser.
     Needs to be called when the page is already loaded. - sidki
     ==================================== */

  function PrxGetEl() {
    prxElement = (
      (!prxIsOp && document.compatMode && document.compatMode == "CSS1Compat")
      || !document.body) ? document.documentElement : document.body;
  }

  /* ====================================
     Proxomitron Menu  Part I. - sidki
     ==================================== */

  var prxTools;
  if (prxTools) {
    var prxTstyle = (document.styleSheets) ? 1 : "";

    function PrxMWrite(debug, light, layout, script, spoof, top, up, css, url_e) {

      // Prefetch menu icons.
      var cold = "http:/" + prxCfgDir + "prox_cold.gif",
      hot = "http:/" + prxCfgDir + "prox_hot.gif",
      pic = new Array();
      pic[0] = new Image();
      pic[0].src = cold;
      pic[1] = new Image();
      pic[1].src = hot;

      // Set vars for the menu.
      var here = window.location, url = unescape(url_e), path, base;
      if (here.protocol.match(/^(about|keyword):/)) {
        var urlA = url.match(/^([^:]+:\/\/[^\/]+)(\/([^\/?]+\/)*)/);
        path = urlA[0];
        base = urlA[1];
      } else {
        base = (here.protocol + "//" + here.host);
        path = base + here.pathname;
      }
      var hostA = url.match(/:\/\/([^\/]+)/)[1],
      wname = (window.name) ? window.name.match(/^(.{1,15}).*/i)[1] :"Dynamic",
      quirk = document.compatMode,
      size = (typeof document.fileSize == "string") ? document.fileSize + " bytes" : "Navigate",
      anc = "\n<div class=\"ProxMCont\"><a class=\"ProxMLink\"",
      targP = (prxTools == 2) ? " target=_blank" : " target=_top",
      togglestyle = (css && prxTstyle) ? anc + " href=\"javascript:ProxMlTStyle()\">Toggle Styles (" + css + ") &#8756;</a>" : "",
      viewvars = (prxIsMoz || prxIsOp) ? anc + " href=\"javascript:ProxMlJSvars()\">JS Variables &#8756;</a>" : "",
      comm1 = anc + targP + " href=\"" + path + here.search + "?prx-command=",
      comm2 = here.hash + "\">",
      select = anc + " href=\"javascript:var q = &quot;&quot; + (window.getSelection ? window.getSelection() : document.getSelection ? document.getSelection() : document.selection.createRange().text); var s = (window.opera) ? &quot;&quot; : &quot;You didn't select any text.  &quot;; if (!q) q = prompt(s + &quot;Enter a host name or leave empty for current host:&quot;, &quot;&quot;); if (q==&quot;&quot || (q==null && parent.frames.length > 0)) q=&quot;" + hostA + "&quot;; if (q!=null) ",
      check = anc + "><label class=\"ProxMLink\"><input class=\"ProxMLink\" type=checkbox value=";

      debug = (debug) ? check + "\"i_debug:0\" /><strong>Standard</strong> Mode</label></a></div>" : check + "\"i_debug:2\" /><strong>Debug</strong> Mode</label></a></div>";
      light = (light) ? check + "\"i_light:0\" /><strong>Full</strong> Settings</label></a></div>" : check + "\"i_light:2\" /><strong>Light</strong> Settings</label></a></div>";
      layout = (layout) ? check + "\"i_layout:0\" /><strong>Keep</strong> Layout</label></a></div>" : check + "\"i_layout:2\" /><strong>Alter</strong> Layout</label></a></div>";
      script = (script) ? check + "\"i_script:0\" /><strong>Allow</strong> Scripts</label></a></div>" : check + "\"i_script:2\" /><strong>Block</strong> Scripts</label></a></div>";
      spoof = (spoof) ? check + "\"i_spoof:0\" /><strong>Don't</strong> spoof IP</label></a></div>" : check + "\"i_spoof:2\" /><strong>Spoof</strong> IP</label></a></div>";
      top = (top) ? anc + " target=_top href=\"" + top + "\">Top</a></div>" : "";
      up = (up) ? anc + " target=_top href=\"" + up + "\">Up</a></div>" : "";

      document.write(
        // Write the icon
        "\n\n<div id=proxMIcon style=visibility:hidden>\n<a" +
        " onmouseover=\"proxIcon.src='" + hot + "';PrxMShow();\"" +
        " onmouseout=\"proxIcon.src='" + cold + "';PrxMHide();\"" +
        " onclick=\"this.style.display = 'none';\"" +
        ">\n<img name=proxIcon src=\"" + cold + "\" alt=\"\" />" +
        "\n</a></div>" +

        // Write the menu
        "\n<div id=proxMDiv onmouseover=clearTimeout(prxTidM); onmouseout=PrxMHide(); style=visibility:hidden>" +
        "\n<table class=\"ProxMTab\"><tbody><tr>" +

        "\n<td class=\"ProxMTdL\">" +
        "\n<div class=\"ProxMSep\">" + wname + "</div>" +
        anc + " href=\"javascript:PrxToggle('Prox','cl','span',1)\" target=\"_self\">Toggle Kills &#8756;</a></div>" +
        togglestyle +
        anc + " href=\"javascript:ProxMlTParent()\">Toggle DOM Path &#8756;</a></div>" +
        anc + " href=\"javascript:PrxMlTopo()\">Toggle Topo View &#8756;</a></div>" +
        anc + " href=\"javascript:for(i=0;i<10000;i++){window.clearInterval(i);window.clearTimeout(i)}\">Kill Timers &#8756;</a></div>" +

        "\n<div class=\"ProxMSep\">" + quirk + "</div>" +
        anc + " href=\"javascript:with(window.open('" + prxCfgDir + "shell.html','prx_bookmarklet','width=663,left='+screen.width*.01+',top='+screen.width*.15+',height='+screen.height*.6+',resizable'));[].v\">JavaScript Shell &#8756;</a></div>" +
        viewvars +
        anc + " href=\"javascript:ProxMlIDs()\">Classes &amp; IDs &#8756;</a></div>" +
        anc + " href=\"javascript:ProxMlDynSrc()\">DHTML Source &#8756;</a></div>" +
        anc + " href=\"javascript:function PrxDocProps(){var i,f,g=0,h=document.links;for(i=0;i<h.length;i++){f=h[i];if(f.className.match(/^Prox/))g++};var a='Window name: '+window.name+'\\nLast modified: '+document.lastModified +'\\nNumber of images: '+(document.images.length-1)+'\\nNumber of links: '+(h.length-g)+'\\nNumber of forms: '+(document.forms.length-1)+'\\nNumber of embedded objects: '+document.embeds.length+'\\n';var prxz=prxAlertP?PrxOldAlert:alert;prxz(a)};PrxDocProps()\">Doc Properties &#8756;</a></div>" +

        "\n<div class=\"ProxMSep\">Verify</div>" +
        anc + targP + " href=\"http://pgl.yoyo.org/adservers/serverlist.php?hostformat=hosts&amp;showintro=0\">Ad Lists</a></div>" +
        anc + targP + " href=\"http://www.sysinfo.org/bholist.txt\">Bad ClsIDs</a></div>" +
        anc + targP + " href=\"http://www.geocities.com/sidki3003/prox-down.html\">Config Updates</a></div>" +

        "\n<div class=\"ProxMSep\">Translate</div>" +
        anc + targP + " href=\"http://translate.google.com/translate_c?u=" + escape(url) + "\">Google: automatic</a></div>" +
        anc + targP + " href=\"http://babelfish.altavista.com/babelfish/trurl_pagecontent?lp=ru_en&amp;url=" + escape(url) + "\">BabelFish: Russian</a></div>" +
        anc + targP + " href=\"http://babelfish.altavista.com/babelfish/tr?url=" + escape(url) + "\">BabelFish: choose</a></div>" +
        anc + targP + " href=\"http://www.tranexp.com:2000/Translate/index.shtml?type=url&amp;url=" + escape(url) + "\">InterTran: choose</a></div>" +

        "\n</td><td class=\"ProxMTdL\">" +
        "\n<div class=\"ProxMSep\">" + size + "</div>" +
        top +
        up +

        "\n<div class=\"ProxMSep\">Prox</div>" +
        comm1 + "src.." + comm2 + "src</a></div>" +
        comm1 + "src..bweb.." + comm2 + "src..bweb</a></div>" +
        comm1 + "dbug.." + comm2 + "dbug</a></div>" +
        comm1 + "bweb.." + comm2 + "bweb</a></div>" +
        comm1 + "bypass.." + comm2 + "bypass</a></div>" +

        "\n<div class=\"ProxMSep\">Site</div>" +
        anc + targP + " href=\"http://validator.w3.org/check?uri=" + url + "&amp;ss=1&amp;sp=1&amp;noatt=1&amp;verbose=1\">Validate</a></div>" +
        anc + targP + " href=\"http://uptime.netcraft.com/up/graph/?host=" + hostA + "\">Netcraft</a></div>" +
        anc + targP + " href=\"http://www.google.com/search?q=cache:" + url + "\">Cached</a></div>" +
        anc + targP + " href=\"http://web.archive.org/web/*/" + url + "\">Wayback</a></div>" +
        anc + targP + " href=\"http://www.alexa.com/data/details/main?url=" + url + "\">Alexa</a></div>" +
        anc + " href=\"javascript:(function(){var w1='',w2='prx_bookmarklet',w3='toolbar=0,scrollbars=0,location=1,statusbar=0,menubar=0,resizable=1,left=0,top=100,width=370,height=210',prxLC,x=prxLC?PrxRealOpen(w1,w2,w3):window.open(w1,w2,w3),d=x.document;d.open();d.write('<html><head><title>3000 Italia - Loading...</title></head><body><form name=pform method=POST action=/local.ptron/http://seo.3000.it/lpopularity.php><input name=id type=hidden value=result><input name=url type=hidden value=" + escape(url) + "></form><script>window.setTimeout(&quot;document.pform.submit()&quot;,300);</script></body></html>');d.close();})()\">Popularity &#8756;</a></div>" +
        anc + " href=\"javascript:void(window.open('http://bugmenot.com/view.php?mode=bookmarklet&amp;url='+escape(&quot;" + hostA + "&quot;),'prx_bookmarklet','toolbar=0,scrollbars=1,location=1,statusbar=0,menubar=0,resizable=1,left=20,top=20,width=385,height=350'))\">BugMeNot &#8756;</a></div>" +
        //anc + targP + " href=\"" + base + "/robots.txt\">Robots?</a></div>" +

        "\n<div class=\"ProxMSep\">Host or IP</div>" +
        select + "(function(){var w1='',w2='prx_bookmarklet',w3='toolbar=0,scrollbars=1,location=1,statusbar=0,menubar=0,resizable=1,left=0,top=100,width=350,height=500',prxLC,x=prxLC?PrxRealOpen(w1,w2,w3):window.open(w1,w2,w3),d=x.document;d.open();d.write('<html><head><title>All Net Tools - Loading...</title></head><body><form name=pform method=POST action=http://www.all-nettools.com/toolbox?prx-keyword=.s_flag.><input name=smartwhois type=hidden value=' + escape(q) + '><input name=swsubmit type=hidden value=GO%21></form><script>window.setTimeout(&quot;document.pform.submit()&quot;,300);</script></body></html>');d.close();})()\">SmartWhois &#8756;</a></div>" +
        select + "location=&quot;http://www.samspade.org/t/lookat?a=&quot; + escape(q); void 0\">Whois &#8756;</a></div>" +
        select + "location=&quot;http://www.geobytes.com/iplocator.htm?getlocation&amp;ipaddress=&quot; + escape(q); void 0\">Location &#8756;</a></div>" +
        //anc + " href=\"javascript:var q = &quot;&quot; + (window.getSelection ? window.getSelection() : document.getSelection ? document.getSelection() : document.selection.createRange().text); var s = (window.opera) ? &quot;&quot; : &quot;You didn't select any text.  &quot;; if (!q) q = prompt(s + &quot;Enter a URL or leave empty for current document:&quot;, &quot;&quot;); if (q==&quot;&quot || (q==null && parent.frames.length > 0)) q=&quot;" + url + "&quot;; if (q!=null) location=&quot;http://www.forret.com/projects/analyze/?url=&quot; + escape(q); void 0\">Headers &#8756;</a></div>" +

        "\n</td><td class=\"ProxMTdR\">" +
        "\n<div class=\"ProxMSep\">Allow</div>" +
        "\n<form class=\"ProxMLink\" action=\"\">" +
        check + "\"a_js\" />All JavaScript</label></a></div>" +
        check + "\"a_ads\" />All Ads</label></a></div>" +
        check + "\"a_adban\" />Ad Banners</label></a></div>" +
        check + "\"a_adcomm1.a_adcomm2\" />Ad Comments</label></a></div>" +
        check + "\"a_adcont.a_adform\" />Ad Containers</label></a></div>" +
        check + "\"a_adtab\" />Ad Tables</label></a></div>" +
        check + "\"a_adjs\" />Ad JavaScript</label></a></div>" +
        check + "\"a_redir\" />Redirects</label></a></div>" +
        check + "\"a_rdlink\" />Redirect Links</label></a></div>" +
        check + "\"a_jslink\" />JS Links</label></a></div>" +
        check + "\"a_flash.a_embed\" />Flash & Media</label></a></div>" +
        check + "\"a_ua\" />User-Agent</label></a></div>" +
        "\n<div class=\"ProxMSep\"></div>" +
        light +
        debug +
        layout +
        script +
        spoof +
        "\n<input id=\"proxMBut1\" class=\"ProxMBut\" type=\"button\" value=\"Go\" onClick=\"PrxMForm(this.form,'go')\" />" +
        "\n<input id=\"proxMBut2\" class=\"ProxMBut\" type=\"button\" value=\"Session\" onClick=\"PrxMForm(this.form,'session')\" />" +
        "\n<input id=\"proxMBut3\" class=\"ProxMBut\" type=\"button\" value=\"List\" onClick=\"PrxMForm(this.form,'list')\" />" +
        "\n</form>\n</td>" +

        "</tr></tbody></table></div>"
      );
    }

    // Show the menu
    function PrxMShow() {
      clearTimeout(prxTidM);
      if (prxMID.style.visibility == "visible") {
        return;
      }
      var bodyX = (prxIsMoz) ?
        (prxElement.clientWidth - document.body.clientWidth) / 2 :
        document.body.offsetLeft;
      prxMID.style.left =
        ((window.pageXOffset) ? window.pageXOffset : prxElement.scrollLeft) +
        prxElement.clientWidth - prxMx - bodyX - 50 + "px";
      prxMID.style.top =
        ((window.pageYOffset) ? window.pageYOffset : prxElement.scrollTop) +
        prxElement.clientHeight - prxMID.offsetHeight - 50 + "px";

      function ShowMNow() {
        prxMID.style.visibility = "visible";
      }

      prxTidM = PrxOldSetTimeout(ShowMNow, 150);
    }

    // Hide the menu
    function PrxMHide() {
      clearTimeout(prxTidM);
      if (prxMID.style.visibility == "hidden") {
        return;
      }

      function HideMNow() {
        prxMID.style.visibility = "hidden";
      }

      prxTidM = PrxOldSetTimeout(HideMNow, 150);
    }

    // Toggle topographic view: Shows the nesting level of every element using
    // shading. - Jesse Ruderman, Joseph Pearson, sidki
    var prxTtopo;

    function PrxMlTopo() {
      var s = "body", c = "", I = " !important;", i, b, f, x, h;
      if (prxTtopo == 1) {
        prxTtopo = 0;
        h = document.getElementById("proxTtopo");
        document.getElementsByTagName("head")[0].removeChild(h);
        h = document.styleSheets[0];
      } else {
        if (prxTtopo) {
          if (prxTtopo.disabled == true) {
            prxTtopo.disabled = false;
          } else {
            prxTtopo.disabled = true;
          }
        } else {
          for (i = 0; i < 17; ++i) {
            x = i.toString(16);
            b = i > 15 ? "FFCCCC" : x + x + x;
            f = i > 9 ? "000000" : "FFFFFF";
            c += s + " {background: #" + b + I + "border-color: #" + b + I + "color: #" + f + I + "}\n";
            s += " *";
          }
          if (document.createStyleSheet) {
            prxTtopo = document.createStyleSheet("javascript:'" + c + "'");
          } else {
            prxTtopo = 1;
            h = document.createElement("link");
            h.id = "proxTtopo";
            h.rel = "stylesheet";
            h.href = "data:text/css," + escape(c);
            document.getElementsByTagName("head")[0].appendChild(h);
          }
        }
      }
    }

    // Toggle DOM path: Lists the ancestors of any element you hover over in
    // the status bar. - Jesse Ruderman, sidki
    var prxTparent;

    function ProxMlTParent() {
      if (prxTparent) {
        prxTparent = 0;
        document.onmouseover = PrxDummyZero;
        window.status = "";
      } else {
        prxTparent = 1;
        if (!prxIsIE) {
          delete status;
        }

        function A(n, g) {
          var p = n.parentNode, t = n.tagName, x, y;
          if (!p) {
            return "";
          }
          for (y = 0, x = n.previousSibling; x; x = x.previousSibling) {
            if (x.nodeName == n.nodeName) {
              y++;
            }
          }
          if (!t) {
            return A(p, g);
          }
          var T = t.toUpperCase(), b = (T != "TABLE" &&
            T != "TBODY" && T != "THEAD" && T != "TR"), c = n.className, i = n.id;
          return A(p, " > ") + (b ? T : T.toLowerCase()) + (y ? "[" + (y + 1) + "]" : "") + (c ? "." + c : "") + (i ? "#" + i : "") + (b ? g : " ");
        }

        document.onmouseover = (function (e) {e = e ? e : event;var s, g = e.target;g = g ? g : e.srcElement;eval("try {s = A(g, '');} catch(er) {s = er.message;}");window.status = s + "";return true;});
        window.status = A(document.documentElement, "");
      }
    }

    // Toggle stylesheets. - sidki, Jesse Ruderman
    function ProxMlTStyle() {
      var i, x = document.styleSheets;
      for (i = 0; i < x.length; i++) {
        if (x[i].disabled) {
          x[i].disabled = 0;
        } else {
          if (!x[i].href.match(/\/local.ptron\//i)) {
            x[i].disabled = 1;
            if (prxTstyle) {
              PrxFooter("style", (x[i].href));
              prxTstyle = "";
            }
          }
        }
      }
    }

    // Show all JavaScript variables and functions. - Jesse Ruderman
    function ProxMlJSvars() {
      var i, v, st, w1 = "", w2 = "prx_bookmarklet";
      var w3 = "toolbar=0,scrollbars=1,location=1,statusbar=0,menubar=0,resizable=1,left=0,top=100,width=800,height=600";
      var prxLC, x = prxLC ? PrxRealOpen(w1, w2, w3) : window.open(w1, w2, w3), d = x.document;
      d.open();

      function hE(s) {
        s = s.replace(/&/g, "&amp;");
        s = s.replace(/>/g, "&gt;");
        s = s.replace(/</g, "&lt;");
        return s;
      }

      var ds = "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01//EN\"\n\"http://www.w3.org/TR/html4/strict.dtd\">";
      ds += "\n<html>\n<head>\n<title>All JS Variables and Functions</title>\n<meta http-equiv=\"Content-Type\" content=\"text/html; charset=iso-8859-1\">";
      ds += "\n<style type=\"text/css\">\nbody,td{font:12px/15px Verdana,Arial,sans-serif;color:#313131;background:#CEDFEF;}";
      ds += "\ntd{vertical-align:top;white-space:pre}\ntable,td,th{border:1px solid #91BBE3}\nth.string{text-align:left;padding-left:100px}\ndiv.er{color:red}\n</style>";
      ds += "\n</head>\n<body>\n<table border=1 summary=\"\">\n<thead><tr><th>Variable</th><th>Type</th><th class=string>Value as string</th></tr></thead>\n";
      d.write(ds);
      for (i in window) {
        if (eval("!(i in x)")) {
          v = window[i];
          d.write("<tr><td>" + hE(i) + "</td><td>" + hE(typeof (window[i])) + "</td><td>");
          if (v === null) {
            d.write("null");
          } else {
            if (v === undefined) {
              d.write("undefined");
            } else {
              var e1 = "<div class=er>", e2 = "</div>\n";
              eval("try {st = v.toString(); if (st.length) {d.write(hE(v.toString()));} else {d.write('\xA0');}} catch(er) {d.write(e1 + hE(er.toString()) + e2);}")
            }
          }
          d.write("</td></tr>\n");
        }
      }
      d.write("</table>\n</body>\n</html>\n");
      d.close();
    }

    // Show all classes and IDs used in the document. - Jesse Ruderman, sidki
    function ProxMlIDs() {
      var a = {}, aa = {}, b = [], bb = [], i, e, c, k;
      var ds = "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01//EN\"\n\"http://www.w3.org/TR/html4/strict.dtd\">";
      ds += "\n<html>\n<head>\n<title>All Classes and IDs</title>\n<meta http-equiv=\"Content-Type\" content=\"text/html; charset=iso-8859-1\">";
      ds += "\n<style type=\"text/css\">\nbody,td{font:12px/15px Verdana,Arial,sans-serif;color:#313131;background:#CEDFEF;}";
      ds += "\ntable,td,th{border:1px solid #91BBE3}\ntable{float:left;margin-right:8px}\n</style>";
      ds += "\n</head>\n<body>\n<table border=1 summary=\"\">\n<thead><tr><th>#</th><th>Tag</th><th>className</th></tr></thead>\n";
      for (i = 0; e = document.getElementsByTagName("*")[i]; ++i) {
        c = e.className;
        if (c) {
          k = e.tagName + "." + c;
          a[k] = a[k] ? a[k] + 1 : 1;
        }
      }
      for (k in a) {
        b.push([k, a[k]]);
      }
      b.sort();
      for (i in b) {
        ds += "<tr><td>" + b[i][1] + "</td><td>" + b[i][0].split(".").join("</td><td>") + "</td></tr>\n";
      }
      ds += "</table>\n";
      ds += "<table border=1 summary=\"\">\n<thead><tr><th>#</th><th>Tag</th><th>ID</th></tr></thead>\n";
      for (i = 0; e = document.getElementsByTagName("*")[i]; ++i) {
        c = e.id;
        if (c) {
          k = e.tagName + "." + c;
          aa[k] = aa[k] ? aa[k] + 1 : 1;
        }
      }
      for (k in aa) {
        bb.push([k, aa[k]]);
      }
      bb.sort();
      for (i in bb) {
        ds += "<tr><td>" + bb[i][1] + "</td><td>" + bb[i][0].split(".").join("</td><td>") + "</td></tr>\n";
      }
      ds += "</table>\n</body>\n</html>\n";
      var w1 = "", w2 = "prx_bookmarklet";
      var w3 = "toolbar=0,scrollbars=1,location=1,statusbar=0,menubar=0,resizable=1,left=0,top=150,width=500,height=500";
      var prxLC, x = prxLC ? PrxRealOpen(w1, w2, w3) : window.open(w1, w2, w3), d = x.document;
      d.write(ds);
      d.close();
    }

    // Show DHTML source: Displays the DOM tree of the page as HTML.
    // - Jesse Ruderman
    function ProxMlDynSrc() {

      function htmlEscape(s) {
        s = s.replace(/&/g, "&amp;");
        s = s.replace(/>/g, "&gt;\n");
        s = s.replace(/</g, "&lt;");
        return s;
      }

      var ds = "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01//EN\"\n\"http://www.w3.org/TR/html4/strict.dtd\">";
      ds += "\n<html>\n<head>\n<title>Dynamic Source</title>\n<meta http-equiv=\"Content-Type\" content=\"text/html; charset=iso-8859-1\">"
      ds += "\n<style type=\"text/css\">\nbody,pre{font:12px/20px Verdana,Arial,sans-serif;color:#313131;background:#CEDFEF;}\n</style>";
      ds += "\n</head>\n<body>\n<pre>\n\n" + htmlEscape("<html>" + document.documentElement.innerHTML + "</html>") + "\n</pre>\n</body>\n</html>";
      var x = window.open("", "prx_bookmarklet", "toolbar=0,scrollbars=1,location=1,statusbar=0,menubar=0,resizable=1,left=0,top=100,width=800,height=600");
      x.document.write(ds);
      x.document.close();
    }

    // Say what should happen when clicking the menu buttons. - JD, sidki
    function PrxMForm(form, what) {
      var all ="", here = window.location, el = form.elements, i, f;
      for (i = 0; i < el.length; i++) {
        f = el[i];
        if (f.type == "checkbox" && f.checked) {
          all += f.value + ".";
        }
      }
      if (all && what == "go") {
        var query = here.search.match(/^(.*)\?prx-keyword=/);
        query = (!query) ? here.search : query[1];
        here.href = here.protocol + "//" + here.host + here.pathname + query +
          "?prx-keyword=." + all + here.hash;
      } else {
        if (what == "list") {
          all = (all) ? all : "YOUR_WORD.";
          var hostR = here.hostname.match(/^https\.\.(.+)/)
          hostR = (hostR) ? hostR[1] :
            ((here.protocol == "https:" && !here.port) ? (here.host + ":443") : here.host);
          here.href = "http://add.to.proxlist/" + hostR +
            here.pathname.match(/^\/([^\/]+\/)*/g) +
            "$$$SET(keyword=$GET(keyword)" + all + ")$$" + here.href;
        } else {
          if (what == "session") {
            here.href = "http://add.to.memlist/" +
              "$SET(a=" + all + ")PrxFail$TST()$$" + here.href;
          }
        }
      }
    }

    // Initialize the constant icon position upon first mouse click.
    var prxTidM, prxMID, prxMx; // Avoid strict warning.

    function PrxMInit() {
      prxTidM = 0;
      var naomi = (prxDAll) ?
        document.all.proxMIcon : document.getElementById("proxMIcon");

      function PrxIHide() {
        if (naomi.style.visibility == "hidden") {
          return;
        }

        function HideNowI() {
          naomi.style.visibility = "hidden";
        }

        PrxOldSetTimeout(HideNowI, 150);
      }

      function PrxIHideA(e) {
        if (window.PrxOnresize) {
          if (!e) {
            e = event;
          }
          window.PrxOnresize(e);
        }
        PrxIHide();
      }

      function PrxIShow() {
        if (naomi.style.visibility == "visible") {
          return;
        }
        var bodyX = (prxIsMoz) ?
          (prxElement.clientWidth - document.body.clientWidth) / 2 :
          document.body.offsetLeft;
        naomi.style.left =
          ((window.pageXOffset) ? window.pageXOffset : prxElement.scrollLeft) +
          prxElement.clientWidth - bodyX - 50 + "px";
        naomi.style.top =
          ((window.pageYOffset) ? window.pageYOffset : prxElement.scrollTop) +
          prxElement.clientHeight - 50 + "px";
        naomi.style.visibility = "visible";
      }

      function PrxIShowA(e) {
        if (document.PrxOnclick) {
          if (!e) {
            e = event;
          }

          // Avoid JS error for cached pages in IE.
          eval("try {document.PrxOnclick(e)} catch(er) {}");
        }
        PrxIShow();
      }

      PrxOldSetTimeout(PrxIShow, 150);
      prxElement.onclick = PrxIShow;
      document.onclick = PrxIShowA;
      window.onresize = PrxIHideA;
      window.onscroll = PrxIHide;
      if (prxIsMoz) {
        window.addEventListener("DOMMouseScroll", PrxIHide, false);
      }
      prxMID = (prxDAll) ?
        document.all.proxMDiv : document.getElementById("proxMDiv");
      prxMx = prxMID.offsetWidth;
    }

  }

  /* ====================================
     Last chance to write to the page - sidki
     ==================================== */

  var prxLocURL, prxButton, prxStyleSel;

  // Declare the style selector. - Tantek Celik
  function ProxWlSwitchCSS() {
    var sheets = ",", options = "<option selected>document default</option>";
    for (var i = 0, d = document.styleSheets; i < d.length; i++) {
      var s = d[i];
      var tt = s.title;
      if (tt != "" && tt != undefined) {
        if (sheets.indexOf("," + tt + ",") == -1) {
          sheets += tt + ",";
          options += "<option>" + tt + "</option>";
        }
      }
    }
    var ds = "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01//EN\"\n\"http://www.w3.org/TR/html4/strict.dtd\">";
    ds += "\n<html><head><title>Select Stylesheet</title>\n<meta http-equiv=\"Content-Type\" content=\"text/html; charset=iso-8859-1\">";
    ds += "\n<style type=\"text/css\">\nbody{margin:0;font:12px/20px Verdana,Arial,sans-serif;background:#CEDFEF;}";
    ds += "\ndiv{margin:0;padding:15px 10px 15px 10px}\nselect{width:170px;background:#A5CFF7;}\n</style>";
    ds += "\n<script type=\"text/javascript\">\nfunction choosess(tt){var x=window.opener.document;";
    ds += "for(var i=0,d=x.styleSheets;i<d.length;i++){var s=d[i];var ti=s.title;if(ti!=\"\" && ti!=undefined && ti!=tt)s.disabled=true;else s.disabled=false;}}\n</script>";
    ds += "\n</head>\n<body>\n<div>";
    ds += "\n<select id=\"st\" size=5 onkeypress=\"var k=event.keyCode;if(k==13 || k==3 || k==27){window.close()}\"";
    ds += " onchange=\"if(this.selectedIndex!=-1)choosess(this.options[this.selectedIndex].text);\">" + options + "</select>";
    ds += "\n</div>\n</body></html>";
    var w = window.open("about:blank", "prx_bookmarklet", "left=70,top=130,height=115,width=190");
    w.document.write(ds);
    w.document.close();
    w.focus();
    w.document.getElementById("st").focus();
  }

  function PrxWrite(tag, onload) {
    var wr = "";

    // Clickable flyover  Part II. - Dynamic Drive, sidki, Martin Konicek
    var wf = "<div id=\"proxFlyover\" onMouseover=\"PrxFlClearHide();\" onMouseout=\"PrxFlDynHide(event);\"></div>\n";

    // See if the style selector should be invoked - IE and Mozilla only.
    // - sidki
    if (prxStyleSel && (prxIsMoz || prxIsIE)) {
      for (var i = 0, d = document.styleSheets; i < d.length; i++) {
        var s = d[i], tt = s.title, st;
        if (tt != "" && tt != undefined) {
          st = 1;
        }
      }
      if (st) {
        wr += "<span id=proxBLink class=Prox style=display:inline>&#8593;<a id=proxBLink class=Prox href=\"javascript:ProxWlSwitchCSS()\">styles</a></span>\n";
      }
    }

    // Intercept calls to *.location.replace() Part II - Paul Rupe, sidki
    if (prxLocURL) {
      wr += "<span id=proxRedir class=Prox style=display:inline>" +
        "&#8593;<a id=proxRedir class=Prox href=\"" + prxLocURL +
        " \" target=_top>tame redirect</a></span>\n";
    }

    // Write it - Create DIV Block if not already done so.
    if (wr) {
      if (!tag) {
        wr = "<div class=ProxDiv>\n" + wr;
        wr += "</div>\n";
      }
    }
    document.write(wf + wr);

    // Create a button if specific onload events were found - sidki
    if (onload) {
      PrxOnloadButton();
    }
    if (prxButton) {
      PrxAllEventButton();
    }
  }

  /* ====================================
     Run this function at the very last. - ...
     ==================================== */

  var prxTarget, prxFramed, prxEvents;

  function PrxLastCall() {
    var i, f, d;
    if (prxTarget || prxFramed) {

      // Open offsite links within frames in the top window I. - sidki
      if (prxFramed && !prxIsNN) {
        eval("try {var url = this.location.href; prxFramed = (top.location.href != url)?PrxGetDomain(url):\"\";} catch(er) {prxFramed = PrxGetDomain(url)}");
      }

      // Links stuff
      for (i = 0, d = document.links; i < d.length; i++) {
        f = d[i];

        // Open targets that refer to non-existing windows in the top window.
        // - Paul Rupe
        if (prxTarget && f.target && (prxTarget == 2 || !f.onclick) &&
          !f.className.match(/^Prox/) && !PrxCheckLinkTarget(f.target)) {
          f.target = "_top";
        }

        // Open offsite links within frames in the top window II. - sidki
        if (prxFramed && !f.target &&
          f.href.indexOf("://") != -1 &&
          prxFramed != PrxGetDomain(f.href)) {
          f.target = "_top";
        }
      }

      // Forms stuff.
      if (prxTarget) {
        for (i = 0, d = document.forms; i < d.length; i++) {

          // Open targets that refer to non-existing windows in the top window.
          // - Paul Rupe
          f = d[i];
          if (f.target && !PrxCheckLinkTarget(f.target)) {
            f.target = "_top";
          }
        }
      }

    }

    // Set some of an object's event handlers to null. - Paul Rupe
    if (prxEvents) {

      function PrxClearEvent(a) {
        if (!a) {
          return;
        }
        a.onmouseenter = null;
        a.onmouseleave = null;
        a.onmouseout = null;
        a.onmousewheel = null;
        a.onbeforeunload = null;
        a.onunload = null;
        a.onbeforeprint = null;
        a.onafterprint = null;
        a.onblur = null;
        a.onfocus = null;
        a.onfocusout = null;
        a.onkeydown = null;
        a.onkeypress = null;
        a.onkeyup = null;
        a.oncontextmenu = null;
        a.ondeactivate = null;
        a.onhelp = null;
        a.onlosecapture = null;
        a.onpropertychange = null;
        a.onresize = null;
        a.onscroll = null;
        a.onselect = null;
        a.onselectstart = null;
      }

      PrxClearEvent(document);
      PrxClearEvent(document.body);
      PrxClearEvent(document.documentElement);
      PrxClearEvent(window);
    }

    // Proxomitron Menu  Part II. - sidki
    if (prxTools) {
      if (document.onclick) {
        document.PrxOnclick = document.onclick;
      }
      if (window.onresize) {
        window.PrxOnresize = window.onresize;
      }
      prxElement.onclick = PrxMInit;
      document.onclick = PrxMInit;
      if (!prxDebug) {
        PrxOldSetTimeout("function PrxMWrite(){}", 1);
        PrxOldSetTimeout("function PrxMInit(){}", 1);
      }
    }

    // Overwrite the functions that are not needed anymore.
    if (!prxDebug) {
      PrxOldSetTimeout("function PrxEventButton(){}", 1);
      PrxOldSetTimeout("function PrxAllEventButton(){}", 1);
      PrxOldSetTimeout("function PrxOnloadButton(){}", 1);
      PrxOldSetTimeout("function PrxGetEl(){}", 1);
      PrxOldSetTimeout("function PrxWrite(){}", 1);
    }

    // Anti-Popup Code Part II. - Scott R. Lemmon
    if (prxPopup) {
      if (prxIsNN) {
        document.captureEvents(Event.MOUSEUP);
      }
      if (document.onmouseup) {
        document.PrxOnmouseup = document.onmouseup;
      }
      document.onmouseup = PrxOMUp;
    }

    // Page Load Timer Part II. - hpguru
    if (prxTimer) {
      status = window.defaultStatus =
        ("Load Time: " + ((new Date()).getTime() - prxST.getTime()) / 1000 + " seconds");
    }

    // Restrict Message Boxes Part II. - Paul Rupe
    if (prxAlertP || prxAlertR) {
      prxAlA = 1;
    }

    // All done
    prxLoading = 0;
    if (!prxDebug) {
      PrxOldSetTimeout("function PrxLastCall(){}", 1);
    }
  }

}
